classification
Title: The header files in Include/ have many declarations with no definition
Type: enhancement Stage: resolved
Components: Build Versions: Python 3.9
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: Nosy List: ZackerySpytz, pablogsal, petr.viktorin, serhiy.storchaka, vstinner
Priority: normal Keywords: patch

Created on 2020-01-17 17:47 by pablogsal, last changed 2020-06-09 16:44 by vstinner.

Pull Requests
URL Status Linked Edit
PR 18037 merged pablogsal, 2020-01-17 17:48
Messages (8)
msg360204 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2020-01-17 17:47
There are many declarations that lack definitions in our header files that should be cleaned (linking against those symbols will fail so removing them should be safe if I am not missing something).
msg360207 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-01-17 19:10
Good catch!

All removals LGTM.
msg360229 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2020-01-18 03:15
New changeset cd7db76a636c218b2d81d3526eb435cfae61f212 by Pablo Galindo in branch 'master':
bpo-39372: Clean header files of declared interfaces with no implementations (GH-18037)
https://github.com/python/cpython/commit/cd7db76a636c218b2d81d3526eb435cfae61f212
msg360238 - (view) Author: Zackery Spytz (ZackerySpytz) * (Python triager) Date: 2020-01-18 06:57
The removal of PyNoArgsFunction is the subject of bpo-18091.
msg360240 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2020-01-18 09:06
Maybe backport this change (except PyNoArgsFunction)?
msg360246 - (view) Author: Pablo Galindo Salgado (pablogsal) * (Python committer) Date: 2020-01-18 14:36
> Maybe backport this change (except PyNoArgsFunction)?

I didn't think of backporting to reduce the possibilities of something going wrong, but is true that a backport without PyNoArgsFunction should be harmless.

Reopening the issue meanwhile I do on the backports.
msg371083 - (view) Author: Petr Viktorin (petr.viktorin) * (Python committer) Date: 2020-06-09 08:23
Since the removal of PyNoArgsFunction breaks user code, does it deserve a mention in What's New – Porting to Python 3.9?
msg371125 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2020-06-09 16:44
> Maybe backport this change (except PyNoArgsFunction)?

I don't think that it's a good idea. I suggest to only do cleanup in the master branch, just in case if something goes wrong. Like the PyNoArgsFunction removal :-)
History
Date User Action Args
2020-06-09 16:44:46vstinnersetnosy: + vstinner
messages: + msg371125
2020-06-09 08:23:46petr.viktorinsetnosy: + petr.viktorin
messages: + msg371083
2020-01-18 14:36:32pablogsalsetstatus: closed -> open
resolution: fixed ->
messages: + msg360246
2020-01-18 09:27:00serhiy.storchakalinkissue18091 superseder
2020-01-18 09:06:06serhiy.storchakasetmessages: + msg360240
2020-01-18 06:57:02ZackerySpytzsetnosy: + ZackerySpytz
messages: + msg360238
2020-01-18 03:15:46pablogsalsetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2020-01-18 03:15:05pablogsalsetmessages: + msg360229
2020-01-17 19:10:22serhiy.storchakasetnosy: + serhiy.storchaka
messages: + msg360207
2020-01-17 17:48:33pablogsalsetkeywords: + patch
stage: patch review
pull_requests: + pull_request17436
2020-01-17 17:47:14pablogsalcreate